//	aitendo I2C LN^LCD [LCD16X2-I2C] Cu
//	Rg[: SPLC792AiST7032̌݊j
//	wt]xH쎺	http://jsdiy.webcrow.jp

#ifndef SPLC792ALIB_H_
#define SPLC792ALIB_H_


#include "twilib.h"

extern	void	I2CCHARLCD_Reset();

void	I2CCHARLCD_SlaveSelect(uint8_t sla);
void	I2CCHARLCD_Init();
void	I2CCHARLCD_SendCmd(uint8_t cmd);
void	I2CCHARLCD_SendData(uint8_t data);
void	I2CCHARLCD_Cls();
void	I2CCHARLCD_HomePos();
void	I2CCHARLCD_SetPos(uint8_t row_y, uint8_t column_x);
void	I2CCHARLCD_PutChar(char cc);
void	I2CCHARLCD_PutString(const char* str);
void	I2CCHARLCD_PutStringP(const char* strpgm);
void	I2CCHARLCD_PutUInt(uint16_t n);
void	I2CCHARLCD_PutInt(int16_t n);
void	I2CCHARLCD_PutByte(uint8_t n);
void	I2CCHARLCD_PutWord(uint16_t n);
void	I2CCHARLCD_DefChar(uint8_t id, const uint8_t* dots);

//arduino LiquidCrystalCu̖OiQlj
#define I2CCHARLCD_LiquidCrystal(sla)	I2CCHARLCD_SlaveSelect(sla)	//̓@ڑĂꍇA؂ւړIŌĂяo
#define I2CCHARLCD_begin(sla, cols, rows)	I2CCHARLCD_Init()	//p[^͑S
#define I2CCHARLCD_clear()	I2CCHARLCD_Cls()
#define I2CCHARLCD_home()	I2CCHARLCD_HomePos()
#define I2CCHARLCD_setCursor(col, row)	I2CCHARLCD_SetPos(row, col)
#define I2CCHARLCD_createChar(num, data)	I2CCHARLCD_DefChar(num, data)
#define I2CCHARLCD_write(cc)	I2CCHARLCD_PutChar(cc)
#define I2CCHARLCD_print(str)	I2CCHARLCD_PutString(str)	//p
#define I2CCHARLCD_printDEC(n)	I2CCHARLCD_PutInt(n)	//10i\A16rbg̕萮p
#define I2CCHARLCD_printHEX(n)	I2CCHARLCD_PutByte(n)	//16i\A1oCgp

/*	LCDZbg֐̃ev[g
void	I2CCHARLCD_Reset()
{
	uint8_t resetPinBV = (1 << PORTC3);
	
	DDRC = resetPinBV;
	PORTC = ~resetPinBV;
	_delay_ms(1);
	PORTC = resetPinBV;
	_delay_ms(1);
}
*/

//------------------------------------------
//Rg[ SPLC792A	ߒ`
//------------------------------------------

//Instruction(IS=0)
//LCD_CMD_FUNCTION_SETLCD_SUBCMD_EXTINSTw肵ȂꍇɗLƂȂ閽(*)
//(*)ȊOIS=0/1ŋ
#define	LCD_CMD_CLEAR_DISPLAY	0b00000001
#define	LCD_CMD_RETURN_HOME		0b00000010
#define	LCD_CMD_ENTRY_MODE		0b00000100
#define	LCD_CMD_DISPLAY_MODE	0b00001000
#define	LCD_CMD_CURSOR_MODE		0b00010000	//(*)
#define	LCD_CMD_FUNCTION_SET	0b00100000
#define	LCD_CMD_SET_CGRAM_ADRS	0b01000000	//(*)
#define	LCD_CMD_SET_DDRAM_ADRS	0b10000000

//Instruction(IS=1)
//LCD_CMD_FUNCTION_SETLCD_SUBCMD_EXTINSTw肵ꍇɗLƂȂ閽
#define	LCD_CMD_SET_ICON_ADRS	0b01000000
#define	LCD_CMD_ICON_CONTHI		0b01010000
#define	LCD_CMD_VOLTAGE_CTRL	0b01100000
#define	LCD_CMD_SET_CONTLO		0b01110000


//Instructioñp[^
//(LCD_CMD_AAA | LCD_SUBCMD_XXX1 | LCD_SUBCMD_XXX2 | c)̌`Ŏg

//LCD_CMD_ENTRY_MODE
#define	LCD_SUBCMD_INCREMENT	0b00000010	//͈ʒui߂iw肾Decrementj
#define	LCD_SUBCMD_WITH_SHIFT	0b00000001	//\Vtg𔺂iLCD_CMD_CURSOR_MODEݒ肷j

//LCD_CMD_DISPLAY_MODE
#define	LCD_SUBCMD_SET_DISPLAY	0b00000100	//ʕ\iw肾ƕ\eۂ܂܉ʂj
#define	LCD_SUBCMD_SET_CURSOR	0b00000010	//J[\\iA_[o[\j
#define	LCD_SUBCMD_CURSOR_BLINK	0b00000001	//J[\_łiɔ킳č}X_łj

//LCD_CMD_CURSOR_MODE
#define	LCD_SUBCMD_SHIFT_ON		0b00001000	//DDRAM̕ύXɕ\Vtgiw肾ƃJ[\ړj
#define	LCD_SUBCMD_RIGHT		0b00000100	//EփVtgiw肾ƍցjLAJ[\ړ[h͈ӖȂ

//LCD_CMD_FUNCTION_SET
#define	LCD_SUBCMD_DL8BIT		0b00010000	//Data Length 8-bitiw肾4-bit[hj
#define	LCD_SUBCMD_2LINE		0b00001000	//\2sgpiw肾1ŝݎgp\ɂȂj
#define	LCD_SUBCMD_DBLHEIGHT	0b00000100	//tHg̏c2{[h
#define	LCD_SUBCMD_EXTINST		0b00000001	//Extra Instruction Tablegp

//LCD_CMD_ICON_CONTHI
//ACR\̂ȂfoCXɑ΂ẮA̖߂͖
#define	LCD_SUBCMD_ICON_ON		0b00001000	//ACR\Iɂiw肾ƃItj


#endif	//SPLC792ALIB_H_
